﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace luento14
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Point startPoint = new Point(0,0);

        public MainWindow()
        {
            InitializeComponent();
        }

        private void textBox2_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            // miksei toimi?
            startPoint = e.GetPosition(null);
        }

        private void textBox2_MouseMove(object sender, MouseEventArgs e)
        {
            // Get the current mouse position
            Point mousePos = e.GetPosition(null);
            Vector diff = startPoint - mousePos;
 //           textBox2.Text = startPoint.ToString() + " " + mousePos.ToString();

            if (e.LeftButton == MouseButtonState.Pressed &&
                Math.Abs(diff.X) > SystemParameters.MinimumHorizontalDragDistance ||
                Math.Abs(diff.Y) > SystemParameters.MinimumVerticalDragDistance)
            {
                DataObject dragData = new DataObject("TextBox", sender);
                DragDrop.DoDragDrop((TextBox)sender, dragData, DragDropEffects.Move);
            }
       //     startPoint = mousePos;
        }



        private void listBox3_Drop(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent("TextBox"))
            {
                TextBox txt = e.Data.GetData("TextBox") as TextBox;
                ListBox lista = (ListBox)sender;
                grid.Children.Remove(txt); // pitäisi paremmin tarkistaa minkä sisällä textbox sijaitsee

                lista.Items.Add(txt);
            }

        }

        private void listBox3_DragEnter(object sender, DragEventArgs e)
        {
            if (!e.Data.GetDataPresent("TextBox") || sender == e.Source)
            {
                e.Effects = DragDropEffects.None;
            }

        }

        private void CommonClickHandler(object sender, RoutedEventArgs e)
        {
            // sender on Stackpanel ja e.OriginalSource varsinainen painike
            Button painike = (Button)e.OriginalSource;
            MessageBox.Show(painike.Content.ToString(), "Painikkeen teksti");
        }

        private void OpenCmdExecuted(object sender, ExecutedRoutedEventArgs e)
        {
            Microsoft.Win32.OpenFileDialog dlg = new Microsoft.Win32.OpenFileDialog();
            dlg.ShowDialog();
        }

        private void OpenCmdCanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            if (checkBox1 != null && checkBox1.IsChecked == true) e.CanExecute = true;
        }

        private void label1_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            MessageBox.Show("labelin mouseleft");

        }

        private void grid_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            MessageBox.Show("gridin mouseleft");

        }

        private void grid_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            label1.Content = "käytiin gridin previewmouseleftissä";
            //    MessageBox.Show("gridin Previewmouseleft");
        //    e.Handled = false;
        }



    }

    /// <summary>
    /// Sallii vain numeroiden syöttämisen. Voidaan liittää mihin tahansa textbox-kontrolliin
    /// Kopioitu pienin muutoksin täältä: http://www.mindscapehq.com/blog/index.php/2009/02/01/attached-behaviours-in-wpf/
    /// kannattaa vilkaista myös:
    /// http://eladm.wordpress.com/2009/04/02/attached-behavior/
    /// </summary>
    public static class NumbersOnlyBehaviour
    {
        public static bool GetNumbersOnly(DependencyObject obj)
        {
            return (bool)obj.GetValue(NumbersOnlyProperty);
        }

        public static void SetNumbersOnly(DependencyObject obj, bool value)
        {
            obj.SetValue(NumbersOnlyProperty, value);
        }

        public static readonly DependencyProperty NumbersOnlyProperty =
          DependencyProperty.RegisterAttached("NumbersOnly",
          typeof(bool), typeof(NumbersOnlyBehaviour),
          new UIPropertyMetadata(false, OnNumbersOnlyChanged));

        private static void OnNumbersOnlyChanged(object sender, DependencyPropertyChangedEventArgs e)
        {

            if (!(sender is TextBox)) return;

            TextBox textBox = (TextBox)sender;
            bool isNumberOnly = (bool)(e.NewValue);


            if (isNumberOnly)
                textBox.PreviewTextInput += BlockNonNumbers;
            else
                textBox.PreviewTextInput -= BlockNonNumbers;
        }

        private static void BlockNonNumbers(object sender, TextCompositionEventArgs e)
        {
            foreach (char ch in e.Text)
                if (!Char.IsDigit(ch))
                    e.Handled = true;
        }
    }

    /// <summary>
    /// kopioitu osoitteesta http://www.codeproject.com/Articles/22855/ListBox-Drag-Drop-using-Attached-Properties
    /// </summary>
    class DragAndDrop
    {
        static public ListBox DragSource;
        static public Type DragType;

        #region Helper
        private static object GetObjectDataFromPoint(ListBox source, Point point)
        {
            UIElement element = source.InputHitTest(point) as UIElement;
            if (element != null)
            {
                //get the object from the element
                object data = DependencyProperty.UnsetValue;
                while (data == DependencyProperty.UnsetValue)
                {
                    // try to get the object value for the corresponding element
                    data = source.ItemContainerGenerator.ItemFromContainer(element);

                    //get the parent and we will iterate again
                    if (data == DependencyProperty.UnsetValue)
                        element = VisualTreeHelper.GetParent(element) as UIElement;

                    //if we reach the actual listbox then we must break to avoid an infinite loop
                    if (element == source)
                        return null;
                }

                //return the data that we fetched only if it is not Unset value, 
                //which would mean that we did not find the data
                if (data != DependencyProperty.UnsetValue)
                    return data;
            }

            return null;
        }
        #endregion

        #region DragEnabled
        public static readonly DependencyProperty DragEnabledProperty =
            DependencyProperty.RegisterAttached("DragEnabled",
                typeof(Boolean),
                typeof(DragAndDrop),
                new FrameworkPropertyMetadata(OnDragEnabledChanged));

        public static void SetDragEnabled(DependencyObject element, Boolean value)
        {
            element.SetValue(DragEnabledProperty, value);
        }

        public static Boolean GetDragEnabled(DependencyObject element)
        {
            return (Boolean)element.GetValue(DragEnabledProperty);
        }

        public static void OnDragEnabledChanged(DependencyObject obj, DependencyPropertyChangedEventArgs args)
        {
            if ((bool)args.NewValue == true)
            {
                ListBox listbox = (ListBox)obj;
                listbox.PreviewMouseLeftButtonDown += new MouseButtonEventHandler(listbox_PreviewMouseLeftButtonDown);
            }
        }
        #endregion

        #region DropEnabled
        public static readonly DependencyProperty DropEnabledProperty =
            DependencyProperty.RegisterAttached("DropEnabled",
                typeof(Boolean),
                typeof(DragAndDrop),
                new FrameworkPropertyMetadata(OnDropEnabledChanged));

        public static void SetDropEnabled(DependencyObject element, Boolean value)
        {
            element.SetValue(DropEnabledProperty, value);
        }

        public static Boolean GetDropEnabled(DependencyObject element)
        {
            return (Boolean)element.GetValue(DropEnabledProperty);
        }

        public static void OnDropEnabledChanged(DependencyObject obj, DependencyPropertyChangedEventArgs args)
        {
            if ((bool)args.NewValue == true)
            {
                ListBox listbox = (ListBox)obj;
                listbox.AllowDrop = true;
                listbox.Drop += new DragEventHandler(listbox_Drop);
            }
        }
        #endregion

        static void listbox_Drop(object sender, DragEventArgs e)
        {
            object data = e.Data.GetData(DragType);
            //Change: Check if type is visible, remove only visible items from DragSource...
            if (DragType.IsVisible == true)
                DragSource.Items.Remove(data);
            ((ListBox)sender).Items.Add(data);
        }

        static void listbox_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            DragSource = (ListBox)sender;
            object data = (object)GetObjectDataFromPoint(DragSource, e.GetPosition(DragSource));
            if (data != null)
            {
                // Only get type if it is a valid data object
                DragType = data.GetType();
                DragDrop.DoDragDrop(DragSource, data, DragDropEffects.Copy);
            }
        }
    }

}
